<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

//
// DISPLAY THUMBNAIL HEADER
// kh_mod 0.1.0, add, 0.3.1 changed
function thumbnails_begin($folderID) {
	global $mg2;
	$mg2->headline = ($folderID === 1)?
						  $mg2->gallerytitle
						  :
						  $mg2->br2line($mg2->all_folders[$folderID][2]);
	include_once('skins/'.$mg2->activeskin.'/templates/gallery_header.php');
}

//
// DISPLAY IMAGE OR FOLDER NOT EXISTS
// kh_mod 0.3.0, changed
function notexists($imageID, $folderID='', $page='') {
	global $mg2;
	if ($imageID === 'demaged')
		$noexists = $mg2->lang['requestfolder'] . $mg2->lang['damaged'];
	elseif ((int)$imageID > 0)
		$noexists = $mg2->lang['noimage'];
	else
		$noexists = $mg2->lang['requestfolder'] . $mg2->lang['notexists'];
	$folderID = ($folderID)? $folderID:'1';
	$page		 = ($page)? $page:'1';
	$mg2->headline = $mg2->gallerytitle;
	include_once ('skins/'.$mg2->activeskin.'/templates/gallery_header.php');
	echo '
		<div style="text-align:center;white-space:nowrap;font-weight:bold">
			<div style="margin-top:24px">'.$noexists.'</div>
			<div style="margin-top:15px">
				<a href="'.$mg2->getGalleryLink(array('fID'=>$folderID,'page'=>$page)).'">'
				.$mg2->lang['viewgallery'].'</a>
			</div>
		</div>
	';
	include_once('skins/'.$mg2->activeskin.'/templates/gallery_footer.php');
	exit();
}


class mg2db {

	//
	// READ ENTIRE FLATFILE DATABASE
	// kh_mod 0.3.0, add
	function readDB() {

		// READ FROM MYSQL, kh_mod 0.3.0, add
		return ($this->sqldatabase)?
				 $this->readDBSQL()
				 :
				 $this->readDBFlatfile();
	}

	//
	// READ ENTIRE FLATFILE DATABASE
	// kh_mod 0.3.1, changed
	function readDBFlatfile($pathDB='default') {

		// INIT  RETURN VALUES
		$readFolders = $readImages = false;

		// GET DEFAULT PATH
		if ($pathDB === 'default') {
			$fDB = DATA_FOLDER .'mg2db_fdatabase.php';
			$iDB = DATA_FOLDER .'mg2db_idatabase.php';
		}
		// GET RESTORE PATH, ADMIN ONLY
		elseif ($backup = $this->getBackupPath($pathDB)) {
			$fDB = sprintf($backup, 'fdatabase');
			$iDB = sprintf($backup, 'idatabase');
		}
		else return array($readFolders, $readImages);	// no valid path

		// ************************************ FOLDER DATABASE  ************************************ //

		// RESET FOLDER ARRAY
		$this->all_folders  = array();
		$this->folderautoid = 0;

		$now = time();	// in order to check if the folder or image date in future
		do {
			if (!is_file($fDB)) {
				$this->folderautoid = 1;
				$this->all_folders[$this->folderautoid] = $this->getDefaultRootFolder();
				break; 								// no data file
			}

			$fp = fopen($fDB,'rb');
			if (!is_resource($fp))	break;	// cannot open data file

			$num_records		  = 0;
			$this->folderautoid = trim(fgets($fp,16));
			if (defined('USER_ADMIN')) {
				while (!feof($fp)) {
					if (fgets($fp,2) !== '#')					continue;	// no data row?
					$record = fgetcsv($fp, 8192, "\t");
					if (($folderID = (int)$record[0]) < 1) continue;	// invalid folder id
					$this->all_folders[$folderID] = $record;
					$num_records++;
				}
			}
			else {
				while (!feof($fp)) {
					if (fgets($fp,2) !== '#')					continue;	// no data row?
					$record = fgetcsv($fp, 8192, "\t");
					if (($folderID = (int)$record[0]) < 1) continue;	// invalid folder id
					if ((int)$record[4] > $now)				continue;	// date in future?
					if ((int)$record[5] < 0)   				continue;	// folder locked?
					$this->all_folders[$folderID] = $record;
					$num_records++;
				}
			}
			fclose($fp);
			$readFolders = $num_records;
		}
		while(0);

		// ************************************ IMAGE DATABASE  ************************************ //

		// RESET IMAGE ARRAY
		$this->all_images	= array();
		$this->autoid		= 0;

		do {
			if (!is_file($iDB)) 		break;	// no data file

			$fp = fopen($iDB,'rb');
			if (!is_resource($fp))	break;	// cannot open data file

			$num_records  = 0;
			$this->autoid = trim(fgets($fp,16));
			if (defined('USER_ADMIN')) {
				while (!feof($fp)) {
					if (fgets($fp,2) !== '#')					continue;	// no data row?
					$record = fgetcsv($fp, 8192, "\t");
					if (($imageID = (int)$record[0]) < 1)	continue;	// invalid image id
					$this->all_images[$imageID] = $record;
					$num_records++;
				}
			}
			else {
				while (!feof($fp)) {
					if (fgets($fp,2) !== '#')					continue;	// no data row?
					$record = fgetcsv($fp, 8192, "\t");
					if (($imageID = (int)$record[0]) < 1)	continue;	// invalid image id
					if ((int)$record[4] > $now)				continue;	// date in future?
					if ((int)$record[5] < 0)   				continue;	// folder locked?
					$this->all_images[$imageID] = $record;
					$num_records++;
				}
			}
			fclose($fp);
			$readImages = $num_records;
		}
		while(0);

		return array($readFolders, $readImages);
	}

	//
	// READ ENTIRE MYSQL DATABASE
	// kh_mod 0.3.0, add
	function readDBSQL() {

		// INIT  RETURN VALUES
		$readFolders = $readImages = false;

		// FOLDER DATABASE
		$query = (defined('USER_ADMIN'))?
					'SELECT * FROM `mg2db_fdatabase` WHERE 1'
					:
					// date in past and position >= 0 only
					'SELECT * FROM `mg2db_fdatabase` WHERE
					 timestamp < UNIX_TIMESTAMP() AND position >=0';
		if ($result = mysql_query($query)) {
			$this->all_folders  = array();
			$this->folderautoid = 0;
			while ($record = mysql_fetch_array($result,MYSQL_NUM)) {
				$folderID = (int)$record[0];
				$this->all_folders[$folderID] = $record;
				if ($this->folderautoid < $folderID) $this->folderautoid = $folderID;
			}
			if ($this->folderautoid < 1) {
				$this->folderautoid = 1;
				$this->all_folders[$this->folderautoid] = $this->getDefaultRootFolder();
			}
			$readFolders = mysql_num_rows($result);
		}

		// IMAGE DATABASE
		$query = (defined('USER_ADMIN'))?
					'SELECT * FROM `mg2db_idatabase`'
					:
					// date in past and position >= 0 only
					'SELECT * FROM `mg2db_idatabase` WHERE
					 timestamp < UNIX_TIMESTAMP() AND position >=0';
		if ($result = mysql_query($query)) {
			$this->all_images	= array();
			$this->autoid		= 0;
			while ($record = mysql_fetch_array($result,MYSQL_NUM)) {
				$imageID = (int)$record[0];
				$this->all_images[$imageID] = $record;
				if ($this->autoid < $imageID) $this->autoid = $imageID;
			}
			$readImages = mysql_num_rows($result);
		}
		return array($readFolders, $readImages);
	}

	//
	// DEFAULT ROOT FOLDER
	//  kh_mod 0.3.0, add
	function getDefaultRootFolder() {
		return	array(
						1,							// folderID				[0]
						'root',					// in folder (#id)			[1]
						'',						// folder name			[2]
						'',						// introtext				[3]
						$this->installdate,	// timestamp (publish off)	[4]
						1,							// folder position			[5]
						0,							// imageID for folder icon	[6]
						6,							// folder sort mode		[7]
						'',						// password				[8]
						0,							// number of cols			[9]
						0,							// number of rows			[10]
						0							// folder type				[11]
					);
	}

	//
	// READ THE SETTINGS FROM MYSQL
	// kh_mod 0.3.0, add; 0.4.0 b3 changed
	function read_sDBSQL() {
		// CONNECT TO SQL SERVER
		if (!$con = @mysql_connect(DB_SERVER, DB_USERNAME, DB_PASSWORD)) {
			$message = 'MySQL-Error: No connect!';
			include('admin/fatal_error.php');
			exit();
		}
		// SELECT DATABASE
		if (!$cDB = @mysql_select_db(DB_NAME, $con)) {
			$message = 'MySQL-Error: Database couldn\'t be selected!';
			include('admin/fatal_error.php');
			exit();
		}
		// GET SETTINGS
		$query = 'SELECT * FROM `mg2db_settings`';
		if ($result = mysql_query($query)) {
			$values = mysql_fetch_array($result, MYSQL_ASSOC);
			if (is_array($values)) {
				foreach($values as $key=>$setting) {
					$this->$key = $setting;
				}
				settype($this->metasetting, 'integer');
				settype($this->navtype, 'integer');
				settype($this->showexif, 'integer');
				settype($this->commentsets, 'integer');
				settype($this->foldersetting, 'integer');
				settype($this->layoutsetting, 'integer');
				settype($this->thumbMaxWidth, 'integer');
				settype($this->thumbMaxHeight, 'integer');
				settype($this->imagecols, 'integer');
				settype($this->imagerows, 'integer');
				settype($this->inactivetime, 'integer');
				settype($this->extendedset, 'integer');
				settype($this->installdate, 'integer');
			}
		}
	}

	//
	// SELECT ENTRIES FROM DATABASE
	// kh_mod 0.3.0, changed
	function select($item, &$array, $row, $sortmode=-1) {
		$selectarray = array();
		if (!is_array($array)) return $selectarray;

		foreach ($array as $record) {
			if ($record[$row] == $item) $selectarray[] = $record;
		}
		if ($sortmode > -1 && count($selectarray) > 1) {
			$this->sort($selectarray, $sortmode & 15, $sortmode & 16);
		}
		return $selectarray;
	}

	//
	// SORT SELECT RESULTS
	// kh_mod 0.3.0, changed
	function sort(&$datatable, $field=0, $direct=0) {
		$comp = ($direct)? '$b,$a':'$a,$b';
		$code = '$result=';
		$code.= ($field===2||$field===3||$field===6)?	// folder name/image title, description or file name
				  'strnatcasecmp($a['.$field.'],$b['.$field.']);'
				  :
				  '(int)$a['.$field.'] - (int)$b['.$field.'];';
		$code.= 'return ($result===0)? $a[0]-$b[0]:$result;';
		$comp_func = create_function($comp, $code);
		usort($datatable, $comp_func);
	}

	//
	// GET SORT MODE FOR FOLDER
	// kh_mod 0.3.0, add
	function getFolderSortMode($folderID=false) {

		// USE GLOBAL SORT SETTING
		if ($this->foldersetting & 15) {
			$tmp_sortmode = $this->foldersetting;
		}
		// USE FOLDER SETTING WITH ID
		elseif (isset($this->all_folders[$folderID])) {
			$tmp_sortmode = (int)$this->all_folders[$folderID][7];
		}
		// USE CURRENT FOLDER SETTING
		else {
			$tmp_sortmode = $this->images_sortmode;
		}

		// MAP IMAGE SORT MOD TO FOLDER
		switch ($tmp_sortmode & 15) {
			case  6 : $trans_sortby = 2; break;	// filename	->	foldername
			case  2 : $trans_sortby = 5; break;	// title		->	position
			case  3 : $trans_sortby = 3; break;	// description->	description
			case 12 : $trans_sortby = 5; break;	// filesize	->	position
			case  8 : $trans_sortby = 5; break;	// width		->	position
			case  9 : $trans_sortby = 5; break;	// height		->	position
			case  4 : $trans_sortby = 4; break;	// timestamp	->	timestamp
			case  5 : $trans_sortby = 5; break;	// position	->	position
			default : $trans_sortby = 2;
		}

		return ($trans_sortby | ($tmp_sortmode & 16));
	}

	//
	// BUILD A LINK FOR GALLERY
	// kh_mod 0.3.1, changed
	function getGalleryLink($param=array()) {

		// SEO LINK
		if ($this->extendedset & 32) {

			$raw_link = array('index'=>'index', 'showform'=>'', 'page'=>'', 'term'=>'.html');

			// FOLDER PAGE
			if (!empty($param['page'])) {
				$raw_link['page'] = '-'. $param['page'];
				unset($param['page']);
			}

			// FOLDER ID
			if (!empty($param['fID'])) {
				$raw_link['index'] = 'folder'. (int)$param['fID'];
				unset($param['fID']);
			}
			// IMAGE ID
			elseif (!empty($param['iID'])) {
				$raw_link['index'] = 'image'. (int)$param['iID'];
				unset($param['iID']);
				if (!empty($param['showform'])) {
					$raw_link['showform'] = '-showform';
					unset($param['showform']);
				}
			}
			// SLIDESHOW ID
			elseif (!empty($param['slideshow'])) {
				$raw_link['index'] = 'slideshow'. (int)$param['slideshow'];
				unset($param['slideshow']);
			}

			// BUILD SEO LINK
			$link = implode('', $raw_link);
		}
		else {
			// DEFAULT LINK
			$link = $this->indexfile;
		}

		// QUERY APPENDIX
		$and = '?';
		foreach ($param as $key=>$query) {
			$link.= $and . $key .'='. $query;
			$and  = '&amp;';
		}

		return $link;
	}

	//
	// BUILD A TOKEN FOR VALIDATION FORM REQUESTS
	// kh_mod 0.3.1, add
	function getVerificationToken($n=6) {
		// INIT VERIFY TOKEN
		$token = '';

		// DEFINE AVAILABLE CHARS
		$availableChars = "23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ";
		$maxCharsIndex  = strlen($availableChars) - 1;

		// CONCATENATE RANDOM CHARS TO TOKEN
		for ($idx=0; $idx<$n; $idx++) {
			$availableChars = str_shuffle($availableChars);
			$token 			.= $availableChars[mt_rand(0, $maxCharsIndex)];
		}

		return (string)$token;
	}

	//
	// DISPLAY SLIDIESHOW ICON
	// kh_mod 0.3.0, changed
	function displaySlideshowIcon($attrib='',$inactiv=false) {
		if (!empty($this->startimage)) {
			$image = '<a href="'. $this->startimage .'">';
			$image.= '<img src="skins/'. $this->activeskin .'/images/slideshow.gif" ';
			$image.= 'width="15" height="17" '. $attrib .' alt="'. $this->lang['viewslideshow'];
			$image.= '" title="'. $this->lang['viewslideshow'] .'" border="0" /></a>';
			echo $image;
		} elseif ($inactiv) {
			$image = '<img src="skins/'. $this->activeskin .'/images/slideshow.gif" ';
			$image.= 'width="15" height="17" '. $attrib .' alt="" border="0" />';
			echo $image;
		}
	}

	//
	// IMAGE NAVIGATION
	// kh_mod 0.3.0, changed
	function imagenavigation($imageID, $thumbset=false) {

		// GET FOLDER ID AND IMAGES
		$folderID = (int)$this->all_images[$imageID][1];
		$images   = $this->select($folderID, $this->all_images, 1, $this->images_sortmode);

		// ONLY ONE IMAGE?
		if (($totalImages = count($images)) < 2) return array(1,-1,-1);

		// NUMBER OF FOLDERS - ADMIN OR SHOW FOLDERS IN CATEGORIES
		$cfolders = (defined('USER_ADMIN') || ($this->foldersetting & 1024))?
						0
						:
						count($this->select($folderID, $this->all_folders, 1));

		// CALCULATE CURRENT PAGE
		$currPage  = 1;
		$currImage = 0;
		$currCols  = (int)$this->all_folders[$folderID][9];	// local setting
		$currRows  = (int)$this->all_folders[$folderID][10];	// local setting
		if ($currCols < 1) $currCols = $this->imagecols;		// glabal setting
		if ($currRows < 1) $currRows = $this->imagerows;		// glabal setting
		for ($i=0; $i < $totalImages; $i++) {
			if ($imageID == $images[$i][0]) {
				$currImage = $i + 1;
				$currPage  = (int)ceil(($currImage + $cfolders) / ($currCols * $currRows));
				break;
			}
		}

		// NAVIGATION ACTIV
		$activ['first'] = (bool)($images[0][0] != $imageID);
		$activ['prev']  = (bool)(isset($images[$currImage - 2][0]));
		$activ['next']  = (bool)(isset($images[$currImage][0]));
		$activ['last']  = (bool)($images[$totalImages - 1][0] != $imageID);

		// QUERIES FOR NAVIGATION STRING
		if ($activ['first']) $queries['first'] = array('iID'=>$images[0][0],'page'=>$currPage);
		if ($activ['prev'])  $queries['prev']  = array('iID'=>$images[$currImage - 2][0],'page'=>$currPage);
		if ($activ['next'])  $queries['next']  = array('iID'=>$images[$currImage][0],'page'=>$currPage);
		if ($activ['last'])  $queries['last']  = array('iID'=>$images[$totalImages - 1][0],'page'=>$currPage);

		// NAVIGATION LINKS FOR ADMIN
		if (defined('USER_ADMIN')) {
			$str_navlink = '<a href="'. ADMIN_INDEX .'?editID=%s&amp;page=%s">%%s</a>';
			foreach ($queries as $key=>$query) {
				$links[$key] = vsprintf($str_navlink, $query);
			}
		}
		// NAVIGATION LINKS FOR GALLERY
		else {
			$str_navlink = '<a href="%s">%%s</a>';
			foreach ($queries as $key=>$query) {
				$links[$key] = sprintf($str_navlink, $this->getGalleryLink($query));
			}
		}

		// IMAGE NUMBER OF TOTAL
		$this->nav_this = sprintf('%d %s %d', $currImage, $this->lang['of'],	$totalImages);

		if ($this->navtype & 1)	$this->text_imagenavigation($links, $activ);
		if ($this->navtype & 2) $this->icon_imagenavigation($links, $activ);
		if ($this->navtype & 4) $this->thumb_imagenavigation($currImage, $images, $thumbset);

		return array(
					$currPage,
					($activ['prev'])?$images[$currImage - 2][0]:-1,	// prev image id
					($activ['next'])?$images[$currImage][0]:-1		// next image id
				);
	}

	//
	// IMAGE NAVIGATION BY TEXTSTRING
	// kh_mod 0.3.0, changed
	function text_imagenavigation($links, $activ) {
		// FIRST IMAGE
		$this->nav_first = ($activ['first'])?
								 sprintf($links['first'], $this->lang['first'])
								 :
								 $this->lang['first'];

		// PREV IMAGE
		$this->nav_prev = ($activ['prev'])?
								sprintf($links['prev'], $this->lang['prev'])
								:
								$this->lang['prev'];

		// NEXT IMAGE
		$this->nav_next = ($activ['next'])?
								sprintf($links['next'], $this->lang['next'])
								:
								$this->lang['next'];

		// LAST IMAGE
		$this->nav_last = ($activ['last'])?
								sprintf($links['last'], $this->lang['last'])
								:
								$this->lang['last'];
	}

	//
	// IMAGE NAVIGATION BY ICONS
	// kh_mod 0.3.0, changed
	function icon_imagenavigation($links, $activ) {

		$navigation = array ('first' => 'nav_first',
									'prev'  => 'nav_prev',
									'next'  => 'nav_next',
									'last'  => 'nav_last'
								  );

		// GENERATE NAVIGATION STRINGS
		$iconpath = (defined('USER_ADMIN'))?
						ADMIN_FOLDER .'images/'
						:
						'skins/'. $this->activeskin .'/images/';
		foreach ($navigation as $key=>$item) {
			if ($activ[$key]) {
				$icon  = $iconpath . $key .'_activ.gif';
				$size	 = (is_readable($icon))? getimagesize($icon):'';
				$image = '<img class="icon" src="'. $icon .'" '. $size[3] .' alt="'. $this->lang[$key];
				$image.= '" title="'.$this->lang[$key].'" />';
				$this->$item = sprintf($links[$key], $image);
			}
			else {
				$icon  = $iconpath . $key .'_inactiv.gif';
				$size  = (is_readable($icon))? getimagesize($icon):'';
				$image = '<img class="icon" src="'. $icon .'" '. $size[3] .' alt="" />';
				$this->$item = $image;
			}
		}
	}

	//
	// IMAGE NAVIGATION BY THUMBS
	// kh_mod 0.2.0, add, 0.3.3 changed
	function thumb_imagenavigation($currImage, &$images, $thumbset) {

		// SET THUMB NUMBER AND SIZE
		$nthumbs = 5;		// default displayed nav thumbs total
		$divisor = 2.5;	// default divisor (thumb size)
		$poscurr = 3;		// default position of current thumb
		$isuffix = '';		// image suffix
		if (is_array($thumbset)) {
			$nthumbs = ($thumbset['num'] < 1)? 0:  (int)$thumbset['num'];
			$divisor = ($thumbset['div'] < 1)? 1:(float)$thumbset['div'];
			$poscurr = (int)ceil($nthumbs/2);
		}
		elseif (defined('USER_ADMIN')) {
			$divisor = 3.2;
			$isuffix = (string)('?'. rand(0,10000));
		}

		// GET START AND END INDEX
		$totalImages = count($images);
		$idx = ($currImage > $poscurr)? $currImage - $poscurr : 0;
		if ($idx + $nthumbs < $totalImages)
			$end = $idx + $nthumbs;
		else {
			$end = $totalImages;
			$idx = ($end > $nthumbs)? $end - $nthumbs : 0;
		}

		// CREATE THUMB NAVIGATION LINE
		$imagetag		 = '<img class="%s" src="./%s'.$isuffix.'" %s title="%4$s" alt="%4$s" />';
		$this->nav_this = '';
		for (; $idx < $end; $idx++) {
			$title		 = ($idx+1) .' '. $this->lang['of'] .' '. $totalImages;
			$thumbwidth  = max((int)round($images[$idx][10]/$divisor), 5);
			$thumbheight = max((int)round($images[$idx][11]/$divisor), 5);
			$thumbsize	 = 'width="'.$thumbwidth.'" height="'.$thumbheight.'"';
			$thumbfile	 = $this->get_path($images[$idx][6],$images[$idx][7],'thumb');
			if ($currImage == $idx+1) {
				$class = 'activ';
				$this->nav_this.= sprintf($imagetag, $class, $thumbfile, $thumbsize, $title);
				$this->nav_this.= "&nbsp;\n";
			}
			elseif (is_readable($thumbfile)) {
				$class = 'inactiv';
				$this->nav_this.= (defined('USER_ADMIN'))?
										sprintf("<a href=\"%s?editID=%s\">%s</a>&nbsp;\n",
											ADMIN_INDEX,
											$images[$idx][0],
											sprintf($imagetag, $class, $thumbfile, $thumbsize, $title)
										)
										:
										sprintf("<a href=\"%s\">%s</a>&nbsp;\n",
											$this->getGalleryLink(array('iID'=>$images[$idx][0])),
											sprintf($imagetag, $class, $thumbfile, $thumbsize, $title)
										);
			}
		}
	}

	//
	// CREATE METATAG TITLE
	// kh_mod 0.2.0, add, kh_mod 0.3.0, changed
	function getPagetitle($imageID, $folderID, $delimiter=' - ') {
		$metatitle	  = array();
		$foldername	  = trim($this->all_folders[$folderID][2]);
		$imagetitle	  = $imageID ? trim($this->all_images[$imageID][2]):'';
		$filename	  = $imageID ? $this->getFilename($imageID):'';
		$gallerytitle = trim($this->gallerytitle);
		if (!$gallerytitle) $gallerytitle = ucfirst(trim($this->lang['gallery']));

		// GALLERY TITLE
		if ($this->metasetting & 1)						$metatitle[] = strip_tags($gallerytitle);
		// FOLDER NAME
		if ($this->metasetting & 2) if ($foldername)	$metatitle[] = strip_tags($foldername);
		elseif ($folderID == 1 && empty($metatitle))	$metatitle[] = strip_tags($gallerytitle);
		// FILE NAME
		if ($this->metasetting & 4 && $filename)		$metatitle[] = $filename;
		// IMAGE TITLE
		if ($this->metasetting & 8 && $imagetitle)	$metatitle[] = $imagetitle;

		// RETURN METATEG TITEL, kh_mod 0.3.5, changed
		return $this->htmlchars2entities(implode($delimiter, $metatitle), ENT_QUOTES);
	}

	//
	// CREATE METATAG TITLE
	// kh_mod 0.3.0, add
	function getFilename($imageID) {

		$filename = trim($this->all_images[$imageID][6]);

		// ORIGINAL BUT FIRST CAPITAL
		if ($this->layoutsetting & 64) {
			$filename = ucfirst($filename);
		}

		// FIRST CAPITAL ONLY
		elseif ($this->layoutsetting & 128) {
			$filename = ucfirst(strtolower($filename));
		}

		// ALL CAPITALS
		elseif ($this->layoutsetting & 256) {
			$filename = strtoupper($filename);
		}

		// ALL LOWER CASES
		elseif ($this->layoutsetting & 512) {
			$filename = strtolower($filename);
		}

		// WITHOUT EXTENSION?
		if (~$this->layoutsetting & 1024)
			$filename = substr($filename,0,strrpos($filename,'.'));

		return $filename;
	}

	//
	// GALLERY NAVIGATION
	// kh_mod 0.3.0, changed
	function gallerynavigation($delimiter) {
		if (defined('IMAGEVIEW')) {
			$folderID = $GLOBALS['folderID'];
		}
		elseif (!empty($_REQUEST['fID'])) {
			$folderID = $this->parentfolder;
		}
		else {
			$folderID = 'root';
		}

		$path = array();
		do {
			if (!$folderRC = $this->all_folders[$folderID]) break;

			$foldername = (empty($folderRC[2]))?	// kh_mod 0.3.0, changed
								$this->lang['gallery']
								:
								$this->br2line($folderRC[2]);

			$path[$folderID] = sprintf('<a href="%s">%s</a>',
										 $this->getGalleryLink(array('fID'=>$folderID)),
										 $foldername
									 );
			$folderID		  = $folderRC[1];
			if (!empty($path[$folderID])) break;	// circle link!
		}
		while ((int)$folderID > 0);

		// SET LINK TO MAINPAGE, kh_mod 0.3.1, changed
		if (!empty($this->websitelink) && !$this->string_empty($this->websitetext))
			$path[] = '<a href="'. $this->websitelink .'" target="_top">'. $this->websitetext .'</a>';
		echo implode($delimiter, array_reverse($path));
	}

	//
	// PAGE NAVIGATION
	// kh_mod 0.3.0, changed
	function pagenavigation($folderID,$npages,$page=0,$delim=' | ') {
		if ($npages < 2) return;

		// INITIALISE VALUES
		$navlink = '<a href="%s">%s</a>';
		$navarr  = array($this->lang['page']);

		// GENERATE PAGE LINKS
		for ($i=1; $i <= $npages; $i++) {
			if ($page === $i) {
				$navarr[] = $i;
			} else {
				$query	 = array('fID'=>$folderID,'page'=>$i);
				$navarr[] = sprintf($navlink, $this->getGalleryLink($query), $i);
			}
		}

		// ALL PAGES LINK
		if ($page === 'all') {
			$navarr[] = $this->lang['all'];
		} else {
			$query	 = array('fID'=>$folderID, 'page'=>'all');
			$navarr[] = sprintf($navlink, $this->getGalleryLink($query),$this->lang['all']);
		}

		// BUILT NAVIGATION STRING
		return implode($delim, $navarr);
	}

	//
	// GET FOLDER ICON
	// kh_mod 0.3.2, changed
	function getthumb($folderID) {

		$thumbID = ($this->foldersetting & 16)?	// global default folder icon?
					  0
					  :
					  (int)$this->all_folders[$folderID][6];

		do {
			// IMAGE FILE AS FOLDER ICON
			if ($thumbID > 0 && ($iconFile = $this->getThumbIcon($thumbID)))								break;

			// PASSWORD DEFAULT ICON
			if (trim($this->all_folders[$folderID][8]) && ($iconFile = $this->getPasswordIcon()))	break;

			// RANDOM, FIRST OR LATEST IMAGE AS FOLDER ICON
			if ($thumbID < 0 && ($iconFile = $this->getRandomIcon($folderID, $thumbID)))				break;

			// DEFAULT FOLDER ICON
			$iconFile = $this->getDefaultIcon($folderID);
		}
		while(0);

		// RETURN ICON FILE, kh_mod 0.3.5, changed
		return $this->cleanURLString($iconFile);
	}

	//
	// GET SETTED THUMBNAIL AS FOLDER ICON
	// kh_mod 0.3.0, add, add, 0.4.0 b4 changed
	function getThumbIcon($thumbID) {

		// GET THE ICON PATH
		$filename = $this->all_images[$thumbID][6];
		$subdir	 = $this->all_images[$thumbID][7];
		$icon		 = $this->get_path($filename, $subdir, 'thumb');

		// IF ICON PATH VALID
		if ($icon !== false || is_file($icon)) {
			$this->width  = (int)$this->all_images[$thumbID][10];
			$this->height = (int)$this->all_images[$thumbID][11];
			$this->subfolder_class = 'subfolder border';
			$iconFile = $icon;
		}
		else {
			$iconFile = false;
		}

		return $iconFile;
	}

	//
	// GET DEFAULT ICON FOR SETTED FOLDER PASSWORD
	// kh_mod 0.3.0, add
	function getPasswordIcon() {
		$iconFile	  = "skins/{$this->activeskin}/images/locked.gif";
		$fileInfo	  = getimagesize($iconFile);
		$this->width  = $fileInfo[0];
		$this->height = $fileInfo[1];
		$this->subfolder_class = 'subfolder';
		return $iconFile;
	}

	//
	// GET FIRST OR RANDOM IMAGE AS FOLDER ICON
	// kh_mod 0.3.0, add, 0.4.0 b4 changed
	function getRandomIcon($subfolderID, $thumbID) {

		$thumbID  = abs($thumbID);
		$iconFile = false;

		// FIRST IMAGE
		$sortmode = ($thumbID & 2)?
						(int)$this->all_folders[$subfolderID][7]			// sortmode of subfolder
						:
						-1;

		// GET ALL IMAGES OF THIS FOLDER
		$images = $this->select($subfolderID, $this->all_images, 1, $sortmode);

		// INCL. SUB FOLDERS?
		if ($thumbID & 8) {
			// RANDOM OR LATEST IMAGE
			if ($thumbID & 5) {
				$subfolders = $this->select($subfolderID, $this->all_folders, 1, -1);
				foreach ($subfolders as $folderRC) {
					if (trim($folderRC[8]) !== '') continue;				// is password set

					$images = array_merge($images, $this->select($folderRC[0], $this->all_images, 1, -1));
				}
			}
			// FIRST IMAGE
			elseif (!$images) {
				$sortmode   = $this->getFolderSortMode($sortmode);		// sortmode of sub sub folder
				$subfolders = $this->select($subfolderID, $this->all_folders, 1, $sortmode);
				foreach ($subfolders as $folderRC) {
					if (trim($folderRC[8]) !== '') continue;				// is password set

					$images = $this->select($folderRC[0], $this->all_images, 1, (int)$folderRC[7]);
					if ($images) break;
				}
			}
		}

		// RANDOM IMAGE, SHUFFLE
		if ($thumbID & 1) {
			shuffle($images);
		}
		// LATEST IMAGE, ORDER BY DATE
		elseif ($thumbID & 4) {
			$this->sort($images, 4, true);
		}

		// DOES FOLDER CONTAIN IMAGES
		while($imageRC = array_shift($images)) {

			// GET THE ICON PATH
			$icon = $this->get_path($imageRC[6], $imageRC[7], 'thumb');

			// IF ICON PATH NOT VALID
			if ($icon === false || !is_file($icon)) continue;

			$this->width  = (int)$imageRC[10];
			$this->height = (int)$imageRC[11];
			$this->subfolder_class = 'subfolder border';
			$iconFile = $icon;
			break;
		}

		return $iconFile;
	}

	//
	// GET DEFAULT ICON
	// kh_mod 0.3.0, add
	function getDefaultIcon($folderID) {

		// FOLDER CONTENT
		$images  = $this->select($folderID, $this->all_images, 1);
		$folders = $this->select($folderID, $this->all_folders, 1);

		// FOLDER NOT EMPTY?
		$iconFile = (count($images) > 0 || count($folders) > 0)?
						"skins/$this->activeskin/images/folder.gif"
						:
						"skins/$this->activeskin/images/emptyfolder.gif";

		// ICON SIZE
		$fileInfo	  = getimagesize($iconFile);
		$this->width  = $fileInfo[0];
		$this->height = $fileInfo[1];
		$this->subfolder_class = 'subfolder';

		return $iconFile;
	}

	//
	// READ FOLDER SETTINGS
	// kh_mod 0.3.0, changed
	function getFolderSettings($folderID) {
		if (!isset($this->all_folders[$folderID])) return false;

		// GET SETTINGS
		$folderRC = $this->all_folders[$folderID];
		$this->parentfolder	  = ($folderID === 1)?
										 'root'
										 :
										 (int)$folderRC[1];
		$this->introtext		  = (!isset($folderRC[3]))?
										 ''
										 :
										 $folderRC[3];
		$this->folder_publish  = (!isset($folderRC[4]))?
										 0
										 :
										 (int)$folderRC[4];
		$this->folder_position = (!isset($folderRC[5]))?
										 1
										 :
										 (int)$folderRC[5];
		$this->images_sortmode = ((int)$folderRC[7] < 1)?
										 6	// sort by by name, ascending
										 :
										 (int)$folderRC[7];
		return true;
	}

	// Nur geeignet, fr das Zhlen der Bilder, nicht aber um ALLE gltigen
	// Ordner zu finden, da der $currentID Folder nicht mit in $subfolders
	// landet, auch dann nicht, wenn er existiert!
	//
	// GET ALL VALID SUB FOLDER IDs
	// kh_mod 0.3.1a, add, 0.3.4 changed
	function getValidSubfolders($currentID) {
		settype($currentID, 'integer');										// set type on integer
		$subfolders = array();													// all valid sub folders
		$folderpath	= array(0=>0);												// first invalid id value

		foreach (array_keys($this->all_folders) as $key) {
			$folderID  = $key;													// to inspect folder id
			$forbidden = $folderpath;											// invalid sub folders

			// GET PATH TO ROOT FOR EACH FOLDER
			do {
				$folderpath[$folderID] = $folderID;							// keep current folder id
				$folderID = (int)$this->all_folders[$folderID][1];		// get parent folder id

				if ($folderID === $currentID)	{
					$subfolders[end($folderpath)][$key] = 1;				// contained in current folder
					$folderpath = $forbidden;									// reset forbidden sub folders
					break;
				}

				if (isset($folderpath[$folderID])) break;					// circle data or folder id == 0
			}
			while (isset($this->all_folders[$folderID]));
		}
		return $subfolders;
	}

	//
	// COUNT PICTURES INCL. ALL SUB FOLDERS
	// kh_mod 0.3.1a, add, 0.3.2 changed
	function countFolderPictures($subfolders) {

		// INIT NUMBER OF PICTURES IN SUB FOLDERS
		$pictures = array();

		// IS SUBFOLDERS EMPTY
		if (empty($subfolders)) return $pictures;

		// IN PHP 5.2 OR ABOVE BETTER 'array_fill_keys'
		foreach ($subfolders as $folderID=>$subs) {
			$pictures[$folderID] = 0;
		}

		// COUNT PICTURES FOR EACH SUB FOLDER
		foreach ($this->all_images as $record) {
			foreach ($subfolders as $folderID=>$subs) {
				if (!isset($subs[(int)$record[1]])) continue;

				$pictures[$folderID]++;	break;		// count and go to next picture id
			}
		}

		// RETURN
		return $pictures;
	}

	//
	// JAVASCRIPT VERIFY FOR COMMENTS
	// kh_mod 0.1.0, add; 0.3.0, changed
	function jsformvalid() {
		$validpath = INC_FOLDER .'mg2_jsformvalid.php';
		if (($this->commentsets & 128) && is_readable($validpath)) {
			include($validpath);
		} else {
			echo '<script language="JavaScript" type="text/javascript">
					<!--
						function validateCompleteForm(a,b) { return true; }
					-->
					</script>';
		}
	}

	//
	// GET GD LIB VERSION
	//
	function gd_version() {
		$gdInfo = gd_info();
		$this->gd_version_number = trim(preg_replace("/[a-z()]/i", "", $gdInfo["GD Version"]));	// kh_mod 0.1.0, changed
		return $this->gd_version_number;
	}

	//
	// GALLERY SECURITY
	// kh_mod 0.3.0, changed
	function gallerysecurity($folderID, $imageID) {

		// FOLDER DISPLAY NOT YET OR FORBIDDEN
		$nextID  = $folderID;
		$pathIDs = array();
		do {
			if (!is_array($this->all_folders[$nextID])) notexists($imageID);
			$pathIDs[$nextID] = $nextID;
			if ((int)$nextID === 1) break;

			$nextID = (int)$this->all_folders[$nextID][1];			// get parent folder ID
			if (isset($pathIDs[$nextID])) notexists('demaged');	// circle link
		}
		while(1);

		// CHECK FOLDER PASSWORD
		foreach ($pathIDs as $id) {
			$folderpwd = trim($this->all_folders[$id][8]);

			// ADMIN MODE?
			if (!empty($_SESSION[GALLERY_ID]['adminmode']) &&
				$_SESSION[GALLERY_ID]['adminmode'] === $this->adminpwd) break;
			if (!empty($folderpwd) && $folderpwd !== $_SESSION[GALLERY_ID]['folderpwd'][$id]) {
				// PASSWORD ENTRY CORRECT?
				if (md5(strrev(md5($_POST['password']))) === $folderpwd) {
					$_SESSION[GALLERY_ID]['folderpwd'][$id] = $folderpwd;
					unset($_POST['password']);
				}
				// PASSWORD DIALOG
				else {
					$this->startimage	 = '';
					$pwdheadline		 = ($_POST['password'])?
												$this->lang['wronglogin']
												:
												$this->lang['enterpassword'];
					$pwdconfirm2url	 = $this->getGalleryLink((empty($imageID))?
												array('fID'=>$folderID)
												:
												array('iID'=>$imageID));
					$_REQUEST['fID']	  = $id;	 								// for gallerynavigation()
					$this->parentfolder = $this->all_folders[$id][1];	// for gallerynavigation()
					thumbnails_begin($id);
					include("skins/$this->activeskin/templates/password.php");
					include("skins/$this->activeskin/templates/gallery_footer.php");
					exit();
				}
			}
			if ($this->extendedset & 1) break;	// folder passwords don't include sub foders
		}
	}

	// kh_mod 0.3.5, changed
	function charfix($string, $trim=false, $html=false) {
		$string = trim($string);

		// REMOVE FURTHER START AND END CHARS
		if ($trim) {
			$string = trim($string, $trim);
		}

		// REPLACE DELIMITER (tab) FOR FLAT FILES
		$string = str_replace("\t", "   ", $string);

		// ELIMINATE MAGIC QUOTS
		if (function_exists('get_magic_quotes_gpc')	&&
			 get_magic_quotes_gpc())
		{
			$string = stripslashes($string);
		}

		return $html ?
				 $this->htmlchars2entities($string, ENT_QUOTES)
				 :
				 $string;
	}

	// kh_mod 0.3.0, add
	function cleanLink($link='') {
		$search  = array('<','>','"',' ','\\');
		$replace = array('%3C','%3E','%22','%20','/');
		return str_replace($search, $replace, trim($link));
	}

	// kh_mod 0.3.0, add
	function cleanTarget($target='') {
		$target = trim($target);
		$regexp = '/^[_a-z][_a-z0-9]{0,64}$/i';
		return (preg_match($regexp, $target))?
				 $target
				 :
				 '_blank';
	}

	/**
	 * CLEAN URL STRING FOR USING AS LINK
	 *
	 * kh_mod 0.3.5, add
	 */
	function cleanURLString($string) {
		return preg_replace_callback('/[^\/]+/', array($this, 'mg2rawurlencode'), $string);
	}

	/**
	 * CALL BACK FUNCTION FOR 'cleanURLString'
	 *
	 * kh_mod 0.3.5, add
	 */
	function mg2rawurlencode($matches) {
		return rawurlencode($matches[0]);
	}

	/**
	 * CONVERT SPECIAL CHARECTERS TO HTML ENTITIES WITH "DOUBLE_ENCODE" OPTION
	 * BACK CONVERTING FROM kh_mod 0.4.x
	 *
	 * kh_mod 0.3.5, add
	 */
	function htmlchars2entities($string, $flags=ENT_COMPAT, $double_encode=false) {

		// IF CHARSET 'Windows-1253' OR 'cp1253' (Greek)
		$charset = (strpos($this->charset, '1253') !== false)?
					  'ISO-8859-1'
					  :
					  $this->charset;

		if (version_compare(PHP_VERSION, '5.2.3', '>=') ) {
			$string = htmlspecialchars($string, $flags, $charset, $double_encode);
		}
		elseif ($double_encode) {
			$string = htmlspecialchars($string, $flags, $charset);
		}
		else {
			$string = $this->htmlspecialcharsFallback($string, $flags);
		}
		return $string;
	}

	// kh_mod 0.3.5, add
	function htmlspecialcharsFallback($string, $flags) {

		$string  = $this->ampers2Entities($string);
		$search	= array('<', '>');
		$replace	= array('&lt;','&gt;');
		if (ENT_NOQUOTES !== $flags) {
			$search[]  = '"';
			$replace[] = '&quot;';
			if (ENT_QUOTES === $flags) {
				$search[]  = '\'';
				$replace[] = '&#039;';
			}
		}
		return str_replace($search, $replace, $string);
	}

	// kh_mod 0.3.5, add
	function ampers2Entities($string) {
		return preg_replace('/&(?!([a-z]{2,8}[1-4]{0,2};))/i', '&amp;', $string);
	}

	// kh_mod 0.3.1, add
	function setTextAlign($subject, $justify) {

		// SPLIT STRING ON TAGS WITH TEXT-ALIGN
		$tags = preg_split('/\<([^><]*text-align\s*:[^><]*)>?/i', $subject, -1, PREG_SPLIT_DELIM_CAPTURE);

		$regexp	= '/text-align\s*:\s*\w*(\s*;)?/i';
		$replace	= 'text-align:'. $justify .';';
		$result	= '';
		foreach($tags as $key=>$tag) {
			$result.= ($key % 2)?
						 sprintf('<%s>', preg_replace($regexp, $replace, rtrim($tag)))
						 :
						 $tag;
		}
		return ($this->string_empty($tags[0]))?		// no intro text or text begin with align tag
				 $result
				 :
				 sprintf('<div style="text-align:%s;">%s</div>', $justify, $result);
	}

	// kh_mod 0.3.0, add, 0.3.5 changed
	function br2line($string) {
		return $string ?
				 preg_replace('/<br[^>]*>/i', ' ', $string)
				 :
				 '';
	}

	// kh_mod 0.3.1a, add, 0.3.5 changed
	function br2nl($string) {
		return $string ?
				 preg_replace("/<br[^>]*>/i", "\n", $string)
				 :
				 '';
	}

	// kh_mod 0.3.0, add, 0.3.5 changed
	function string_empty($string) {
		return (!$string || preg_match('/^(<[^>]*>|&nbsp;|\s)*$/i', $string))?
				 true
				 :
				 false;
	}

	// kh_mod 0.3.0, add
	function mb_shorten($item, $limit, $wildcard='...') {

		// NO CUTTING
		if ($limit === 0) return $item;

		// START AND END VALUES
		$chars  = abs($limit);
		$prefix = $suffix = '';
		$strip  = strip_tags($item);
		if ($limit > 0) {
			$start  = 0;
			$suffix = $wildcard;
		}
		else {
			$start  = $limit;
			$prefix = $wildcard;
		}
		$wildcard = strip_tags($wildcard);	// strip to calculate lenght

		// CUTTING STRING, kh_mod 0.3.1a changed
		if (extension_loaded('mbstring')							&&
			 ($lenght = @mb_strlen($strip, $this->charset))	&&
			 ($bonus  = @mb_strlen($wildcard)) !== false)
		{
			if ($lenght > $chars + $bonus) {
				$item = $prefix . mb_substr($strip, $start, $chars, $this->charset) . $suffix;
			}
		}
		elseif ((strcasecmp($this->charset, 'utf-8'))===0) {
			$bonus = strlen(utf8_decode($wildcard));
			$item_latin = utf8_decode($strip);
			if (strlen($item_latin) > $chars + $bonus) {
				$item = utf8_encode($prefix . substr($item_latin, $start, $chars) . $suffix);
			}
		}
		elseif (strlen($strip) > $chars + strlen($wildcard)) {
			$item = $prefix . substr($strip, $start, $chars) . $suffix;
		}
		return $item;
	}

	// kh_mod 0.3.3, changed
	function readcomments($comment_file) {
		$this->comments	= array();
		$count_comments   = 0;
		$this->commautoid	= 0;
		if (is_readable($comment_file)) {
			$fp = @fopen($comment_file,'r');
			$this->commautoid = trim(fgets($fp,32));
			while ($fp && !feof($fp)) {
				if (fgets($fp,2) !== '#')						continue;	// no data row?
				$record = fgetcsv($fp,4600,"\t");
				if (($commentID = (int)$record[0]) < 1)	continue;	// invalid comment id
				$this->comments[$commentID] = $record;
				$count_comments++;
			}
			fclose($fp);
		}
		elseif (is_file($comment_file)) {
			$this->log("ERROR: Couldn't read comments from '{$comment_file}'!");
			$count_comments = false;
		}
		return $count_comments;
	}

	// kh_mod 0.2.0, changed
	function writecomments($commfile, $todo='add') {
		$fok  = false;
		$ip   = ($this->commentsets & 2048)? getenv('REMOTE_ADDR'):'-';
		$host = ($this->commentsets & 2048)? gethostbyaddr($ip):'-';
		switch ($todo) {
			case 'add':	$todo = 'added to';	 break;
			case 'del':	$todo = 'deleted in'; break;
			default:		$todo = 'changed in';
		}
		do {
			if (is_file($commfile) && !is_writeable($commfile)) {
				$message = 'Comment couldn\'t be '.$todo.' \''.$commfile.'\', since the comment file is write protected';
				break;
			}
			if (!is_writeable($this->imagefolder))	{
				$message = 'Comment couldn\'t be '.$todo.' \''.$commfile.'\', since the image folder is write protected';
				break;
			}
			if (!is_array($this->comments)) {
				$message = 'Comment couldn\'t be '.$todo.' \''.$commfile.'\', since no entries were found.';
				break;
			}
			if (!$fp = fopen($commfile,'w')) {
				$message = 'Commentfile \''.$commfile.'\' couldn\'t be opened for writing';
				break;
			}

			// CREATE DATA CONTENT FOR COMMENT FILE
			$buffer = $this->commautoid ."\n";
			foreach ($this->comments as $record) {
				$buffer.= '#';
				$buffer.= implode("\t",$record);
				$buffer.= "\n";
			}

			if (!flock($fp, LOCK_EX)) {
				$message = 'Commentfile \''.$commfile.'\' couldn\'t be locked for writing';
			}
			elseif ($fok = fwrite($fp, $buffer)) {
				$message = 'Write comment file \''.$commfile.'\'';
			}
			else {
				$message = 'Couln\'t write comment file \''.$commfile.'\'';
			}

			flock($fp, LOCK_UN);	// UNLOCK FILE
			fclose($fp);			// CLOSE FILE
		}
		while(0);

		// WRITE LOG FILE
		$message.= "\n                     ";
		$message.= (($fok)? '(Filesize: '. $fok .' Bytes,':'(From');
		$message.= ' IP: '. $ip .', HOST: '. $host .')';
		$this->log($message);

		return $fok;
	}

	// kh_mod 0.3.1, changed
	function addcomment($filename, $subdir) {
		$add_ok = false;
		do {
			// READ COMMENT FILE
			$commfile = $this->get_path($filename, $subdir, 'comment');
			$comments = $this->readcomments($commfile);
			if ($comments===false) { $this->status = $this->lang['commenterror']; break; }

			// GET AND CLEAN NEW COMMENT INPUT
			$commentID = ++$this->commautoid;
			if ($this->cleancomment($commentID) !== true)	break;

			// WRITE NEW COMMENT
			$add_ok = $this->writecomments($commfile);
			if ($add_ok===false) {
				$this->status = $this->lang['commenterror'];	// for gallery output
			}
			else {
				$this->status = $this->lang['commentadded'];	// for gallery output
				if ($this->commentsets & 32) {					// new comments locked?
					$this->status.= '<br />';
					$this->status.= $this->lang['hintcommentadded'];
				}
			}

			// SEND COMMENT EMAIL, 0.3.5 changed
			if (!($this->commentsets & 64) || !$this->adminemail)		break;
			$HTTPS   = in_array($_SERVER['HTTPS'], array('', 'off')) ? 'http':'https';
			$HOST		= $_SERVER['HTTP_HOST'];
			$SCRIPT	= $_SERVER['SCRIPT_NAME'];
			$imageID	= (int)$_POST['iID'];
			$comment = $this->comments[$commentID];
			$to		= $this->adminemail;
			$subject	= strip_tags($this->gallerytitle) .": ". $this->lang['commentadded'];
			$subject	= sprintf("=?%s?B?%s?=", $this->charset, base64_encode($subject));
			$newline = "\n";
			$body		= sprintf(
								"%s:$newline".
								"%s <%s>$newline$newline".
								"%s:$newline".
								"%s$newline$newline".
								"%s://%s/%s/%s$newline".	// link to gallery item
								"%s$newline",
								$this->lang['from'],
								$comment[1],					// name
								$comment[2],					// email
								$this->lang['comment'],
								$this->br2nl($comment[3]),	// body
								$HTTPS,
								$HOST,
								substr(dirname($SCRIPT), 1),
								$this->getGalleryLink(array('iID'=>$imageID,'user'=>GALLERY_ID)),
								($add_ok)? "":"\nERROR: Couldn't save new comment!"
						  );
			$from   = sprintf("From: %1\$s\nReply-to: %1\$s\nContent-Type: text/plain; charset=%2\$s\n",
							 $comment[2],
							 $this->charset
						 );
			$mailOK = @mail($to, $subject, $body, $from);
			$this->log($mailOK ? "Sent comment by email to admin":"ERROR: Couldn't send new comment by email!");
		}
		while(0);

		return $add_ok;
	}

	// kh_mod 0.3.5, changed
	function cleancomment($commentID) {
		// CLEAN UP INPUT
		$name	  = $this->charfix(substr($_POST['name'],0,90), false, true);
		$email  = $this->charfix(substr($_POST['email'],0,320), false, true);
		$body   = $this->charfix(substr($_POST['body'],0,4096));
		$body	  = (defined('USER_ADMIN'))?
					 strip_tags($body, '<b><i><u><strong><em><br><p><div><span><del><ins><h1><h2><h3><sup><sub>')
					 :
					 strip_tags($body, '<b><i><u><strong><em>');
		$body	  = $this->stripEventHandler($body);
		$body	  = preg_replace('/&(?=(.?[&;\s])|([^;]{5})|([^;]{0,5}$))/', '&amp;', $body);
		$bodybr = (defined('USER_ADMIN') && ($this->extendedset & 4))?	// admin and WYSIWYG HTML-Editor?
					 preg_replace('/\r\n|\r|\n/', '', $body)					// line break stand for data record end
					 :
					 preg_replace('/\r\n|\r|\n/', '<br />', $body);

		// INIT ERROR VALUES
		$clean_ok	  = false;
		$this->status = '';
		do {
			// ARE ALL FIELDS NOT EMPTY?
			if ($email === '' || $name === '' || $body === '') {
				$this->status = $this->lang['commentmissing'];				break;
			}

			// EMAIL CORRECT?
			$cClassLocal  = '[_a-z0-9%{|\/*}-]';
			$cClassSecond = '[a-z0-9'. preg_quote($this->lang['specialchars']) .']';
			$cClassTop    = '[a-z]';
			$regexp       = sprintf('/(^%1$s+([+.]%1$s+)*)@(%2$s+([.-]%2$s+)*\.%3$s{2,8})$/i',
									$cClassLocal,
									$cClassSecond,
									$cClassTop
								 );
			if (!preg_match($regexp, $email, $match)
				 || strlen($match[1]) > 64
				 || strlen($match[3]) > 255)
			{
				$this->status = $this->lang['emailerror']; 					break;
			}

			// CAPTCHA CORRECT?
			if (!defined('USER_ADMIN') && ($this->commentsets & 256)) {
				if (empty($_SESSION[GALLERY_ID]['token']) ||
					(sha1(trim($_POST['captcha'])) !== $_SESSION[GALLERY_ID]['token'])) {
						$this->status = $this->lang['captchaerror'];			break;
				}
			}

			// COMMENT ALLREADY EXISTS?
			if (is_array($this->comments))
			foreach ($this->comments as $record) {
				if ($record[3] === $bodybr	&&			// body field
					 $record[1] === $name	&& 		// name field
					 $record[2] === $email)				// eMail field
				{
					$this->status = $this->lang['commentexists'];			break 2;
				}
			}

			// CHECK WHITELIST
			$list  = 'skins/_global_/checklists/whitelist.php';
			$white = ($this->commentsets & 512)?
						$this->validChecklist($list, $name, $email, $body)
						:
						false;

			// CHECK BLACKLIST
			$list = 'skins/_global_/checklists/blacklist.php';
			if (!$white)
			if ($this->commentsets & 1024)
			if ($this->validChecklist($list, $name, $email, $body)) {
				 $this->status = $this->lang['checklisterror'];				break;
			}

			// INPUT VALUES ARE CLEAN
			$clean_ok = true;

			// USE COMMENT ENTRY WITH <br />
			$body = $bodybr;
		}
		while(0);

		// SAVE NEW COMMENT (GALLERY)
		if (!defined('USER_ADMIN')) {
			$locked = ($this->commentsets & 32)? 0:1;
			$this->comments[$commentID] = array(
													$commentID,		// comment ID
													$name,			// name of poster
													$email,			// email of poster
													$body,			// comment
													time(),			// entry time
													-1,				// last changed
													0,					// count changes
													$locked			// display status
													);
		}
		// CHANGE COMMENT (ADMIN)
		else {
			$this->comments[$commentID][0] = $commentID;	// comment id
			$this->comments[$commentID][1] = $name;		// name of poster
			$this->comments[$commentID][2] = $email;		// email of poster
			$this->comments[$commentID][3] = $body;		// comment
		}

		return $clean_ok;
	}

	//
	// CLEAN COMMENT INPUT FROM EVENTHANDLER
	// kh_mod 0.3.1, add
	function stripEventHandler($subject) {

		// SPLIT STRING ON TAGS WITH EVENT HANDLER
		$tags = preg_split('/\<([^><]*on[^><]*)>?/i', $subject, -1, PREG_SPLIT_DELIM_CAPTURE);

		$regexp	= '/\s*on\w*\s*=\s*([\'"])?[^\1]*?(?(1)\1|[^>]*)/i';
		$replace	= ' ';
		$result	= '';
		foreach($tags as $key=>$tag) {
			$result.= ($key % 2)?
						 sprintf('<%s>', preg_replace($regexp, $replace, rtrim($tag)))
						 :
						 $tag;
		}
		return $result;
	}

	//
	// CHECK WHITE AND BLACK LIST AGAINST COMMENT ENTRIES
	// kh_mod 0.3.0, add
	function validChecklist($path_list, &$name, &$email, &$body) {
		do {
			if (!is_readable($path_list)) {
				$this->log("ERROR: Couldn't read '{$path_list}'");
				break;
			}

			if (!$checklist = file($path_list)) break;

			$ipadd = getenv('REMOTE_ADDR');
			$host  = gethostbyaddr($ip);
			foreach($checklist as $item) {
				$item = trim($item);
				if (empty($item))			continue;
				if ($item{0} === ';')	continue;

				$rule = explode(', ', $item);
				$search = trim($rule[0]);	if (empty($search)) continue;
				$where  = (int)$rule[1];	if (!($where & 63)) continue;

				// STRING SEARCH
				if (empty($rule[2])) {
					if ($where &  1 && (stristr($name,	$search)!==false)) return true;
					if ($where &  2 && (stristr($email, $search)!==false)) return true;
					if ($where &  4 && (stristr($body,	$search)!==false)) return true;
					if ($where &  8 && (stristr($ipadd, $search)!==false)) return true;
					if ($where & 16 && (stristr($host,	$search)!==false)) return true;
				}
				// REG EXP SEARCH
				else {
					if ($where &  1 && preg_match($search, $name))	return true;
					if ($where &  2 && preg_match($search, $email))	return true;
					if ($where &  4 && preg_match($search, $body))	return true;
					if ($where &  8 && preg_match($search, $ipadd))	return true;
					if ($where & 16 && preg_match($search, $host))	return true;
				}
			}
		}
		while(0);

		return false;
	}

	// kh_mod 0.2.0, add, 0.3.1 changed
	function displaycaptcha($width=250, $height=100, $size=22, $wave=2) {
		if		 ($width  > 500) $width  = 500;
		elseif ($width  < 100) $width  = 100;
		if		 ($height > 200) $height = 200;
		elseif ($height <  40) $height =  40;
		if		 ($size   >  36) $height =  36;
		elseif ($size   <  12) $height =  12;
		$_SESSION[GALLERY_ID]['captcha_width']  = $width;
		$_SESSION[GALLERY_ID]['captcha_height'] = $height;
		$_SESSION[GALLERY_ID]['captcha_size']   = $size;
		$_SESSION[GALLERY_ID]['captcha_wave']   = (int)$wave;
		return sprintf('<img src="skins/_global_/captcha/mg2_captcha.php?gID=%s&amp;rl=%d%s" width="%d" height="%d" alt="" />',
						GALLERY_ID,
						mt_rand(1000,9999),
						SID ? '&amp;'. SID:'',
						$width,
						$height
				 );
	}

	// kh_mod 0.1.0 rc1, add, 0.3.5 changed
	function checkLanguage($lang, $user='gallery') {
		$langPath = sprintf('%s%2$s/%2$s.%%s.php', LANG_FOLDER, $lang);
		$testPath = sprintf($langPath, $user);
		return (empty($lang) || !is_readable($testPath))?
				 false
				 :
				 $langPath;
	}

	// kh_mod 0.1.0, changed
	function output($var) {
		echo (isset($this->$var))? $this->$var:'';
	}

	// kh_mod 0.3.1, changed
	function log($entry='', $block=false) {
		$logfile  = DATA_FOLDER .'mg2_log.txt';
		$filesize = (is_file($logfile))? filesize($logfile):-1;

		// ENTRY DATE
		if (!$block) $entry = date('Ymd, H:i:s - ') . $entry . "\n";

		// SHORTEN LARGE LOG FILE
		if ($filesize > 307200 &&									// log file greater than 300 KB
			($content = file($logfile)))							// read file into array
		{
			$filesize = 0;												// write a new file head
			$content	 = array_slice($content, max(count($content) - 360, 0));
			$entry	 = implode('', $content) . $entry;
			unlink($logfile);
		}
		// CHECK FILE STATUS
		elseif (($filesize !== -1)			&&						// file exists
					!is_writeable($logfile)	&&						// but isn't writeable
					!chmod($logfile, 0666)	&&						// chmod don't work
				  ($content = file_get_contents($logfile)))	// but file is readable
		{
			$entry = $content . $entry;
			unlink($logfile);
		}

		// ADD LOG ENTRY
		if ($filesize > 0) {
			$fp = fopen($logfile, 'a+');
		}
		// CREATE NEW LOGFILE
		else {
			$head  = "MG2/kh_mod LFS (Log File System)\n\n";
			$head .= "Version: 0.5.1/$this->modversion\n";
			$head .= "Install date: " . date("Y-m-d",$this->installdate);
			$head .= "\n\n------------------ LOG BEGIN ------------------\n\n";
			$entry = $head . $entry;
			$fp = fopen($logfile, 'wb');
		}
		// WRITE NEW LOG FILE
		if (is_resource($fp)) {
			flock($fp, LOCK_EX);	// do an exclusive lock
			fwrite($fp, $entry);
			flock($fp, LOCK_UN);	// release the lock
			fclose($fp);
		}
	}

	//
	// BUILD PATH FOR IMAGE, MEDIUM, THUMB AND COMMENT
	// kh_mod 0.2.0, add
	function get_path($fname, $subdir, $type='image') {
		$ext = strrchr($fname, '.');
		$len = strlen($ext);
		if ($len > 1) {
			$path = $this->imagefolder . $subdir .'/';
			switch ($type) {
				case 'image':	return $path . $fname;
				case 'medium':	return $path . substr($fname, 0, -$len) .'_medium'. $ext;
				case 'thumb':	return $path . substr($fname, 0, -$len) .'_thumb'. $ext;
				case 'comment':return $path . $fname .'.comment';
			}
		}
		return false;
	}

	//
	// CONVERT DATE TO TIMESTAMP
	// kh_mod 0.1.0 b3, add, 0.3.1 changed
	function date2time($date='') {
		if (empty($date))	return time();

		// DATE FORMAT
		$dateForm = $this->dateformat;

		// ALLOW DATE FORMATS
		$regexp1 = '/(%d|%e)([^%]*)(%b|%m|%n)([^%]*)(%y|%Y)/';  // DAY, MONTH, YEAR
		$regexp2 = '/(%b|%m|%n)([^%]*)(%d|%e)([^%]*)(%y|%Y)/';  // MONTH, DAY, YEAR
		$regexp3 = '/(%y|%Y)([^%]*)(%b|%m|%n)([^%]*)(%d|%e)/';  // YEAR, MONTH, DAY

		// CHECK DATE FORMAT AND SET NEW ORDER (YEAR, MONTH, DAY)
		if (preg_match($regexp1,$dateForm, $item)) {
			$res = array(3,2,1);
		}
		elseif (preg_match($regexp2,$dateForm, $item)) {
			$res = array(3,1,2);
		}
		elseif (preg_match($regexp3,$dateForm, $item)) {
			$res = array(1,2,3);
		}
		else return false;

		// DETERMINE DATE REGEXP
		$regexp = '';
		for ($n=1; $n<6; $n++) {
			switch ($item[$n]) {
				case ''  : $regexp.= '';					break;
				case '%y': 
				case '%Y': $regexp.= '(\d{4}|\d{2})';	break;
				case '%m':
				case '%n':
				case '%d':
				case '%e': $regexp.= '(\d{1,2})';		break;
				case '%b': $cClass = '[\w'.$this->lang['specialchars'].']';
							  $regexp.= '('.$cClass.'{3,15})';
							  break;
				default:   $regexp.= '\W*';	// no letter or digit or the underscore character
			}
		}
		// ADD TIME EXPRESSION
		$regexp = '/'. $regexp .'\D*((\d{1,2})\D+(\d{1,2})[^a-z]*((a|p)(?=\W{0,3}m))?)?/i';

		// GET EACH DATE VALUE
		$timestamp = false;
		if (preg_match($regexp, $date, $split)) {
			$Y = (int)$split[$res[0]];							// YEAR
			$M = $split[$res[1]];								// MONTH
			$D = (int)$split[$res[2]];							// DAY
			$H = (isset($split[4]))? (int)$split[5]:0;	// HOUR
			$i = (isset($split[4]))? (int)$split[6]:0;	// MINUTE

			// AM/PM FORMAT, kh_mod 0.4.0 b3, add
			if (isset($split[7])) {
				$H+= (strcasecmp($split[7],'a') === 0)?
					  (($H > 11)? -12:0)		// AM
					  :
					  (($H < 12)?  12:0);	// PM
			}

			// MONTH TO NUMBER
			if (strlen($M) > 2) {
				for ($n=0; $n<12; $n++) {
					if (strncasecmp($M, $this->lang['months'][$n], 3)===0) break;
				}
				$M = ($n < 12)? ++$n : false;
			} else {
				settype($M, 'int');
			}

			// CHECK DATE
			if (checkdate($M, $D, $Y)) {
				if (($mk = mktime($H, $i, 0, $M, $D, $Y)) > 0) $timestamp = $mk;
			}
		}

		// RETURNS TIMESTAMP OR FALSE
		return $timestamp;
	}

	//
	// CONVERT TIMESTAMP TO DATE
	// kh_mod 0.3.0, changed
	function time2date($timestamp=0, $showTime=true) {
		if ((int)$timestamp < 0) return '&ndash;';

		// TIMESTAMP EMPTY?
		if (empty($timestamp)) $timestamp = time();

		// DATE FORMAT
		$dateForm = ($showTime && !empty($this->timeformat))?
						trim($this->dateformat .', '. $this->timeformat)
						:
						trim($this->dateformat);

		// SIMULATION OF MISSING PARAMETERS
		$search = $replace = array();
		// '%n' AS MONTH  WITHOUT LEADING ZERO
		$search[]  = '%n';
		$replace[] = date('n', $timestamp);
		// '%e' AS DAY WITHOUT LEADING ZERO
		$search[]  = '%e';
		$replace[] = date('j', $timestamp);
		// '%b' AS THREE CHARS OF MONTH (LOCALISED), kh_mod 0.3.1, changed
		$month = (int)date('n', $timestamp) - 1;
		if (!empty($this->lang['months'][$month])) {
			$search[]  = '%b';
			$replace[] = $this->lang['months'][$month];
		}
		// '%r' DISPLAY a.m resp. p.m. STRING
		$search[]  = '%r';
		$replace[] = strtr(date('a', $timestamp), array('am'=>'a.m.','pm'=>'p.m.'));

		// REPLACE
		$dateForm  = str_replace($search,$replace,$dateForm);

		// DATE AND TIME FORMTTED
		return strftime($dateForm, $timestamp);
	}

	//
	// CONVERT A EXIF DATE TO MG2 DATE
	// kh_mod 0.3.0, add; 0.4.0 b4, changed
	function exif2date($date='', $nomatch='&ndash;') {
		$regexp = '/(\d{4})\D*(\d{2})\D*(\d{2})\D+(\d{1,2})?\D+(\d{2})?\D+(\d{2})?/';
		return (preg_match($regexp, $date, $d) && ((int)$d[1] > 1970))?
				 $this->time2date(mktime((int)$d[4], (int)$d[5], (int)$d[6], (int)$d[2], (int)$d[3], (int)$d[1]))
				 :
				 $nomatch;
	}
}	// END CLASS' mg2db'
?>
